﻿using System;
using System.Collections.Generic;
using System.Text;

namespace CinemaPlanningLibrary
{
    public struct Option
    {
        public bool[] Possibilities;
        public int[] Groups;

        public Option(bool[] possibilities, int[] groups)
        {
            this.Possibilities = possibilities;
            this.Groups = groups;
        }
    }

    public class OptionsRetriever
    {
        public static List<List<Option>> GetOptions()
        {
            // Autogenerated lookup table for performance
            return new List<List<Option>>()
            {
                new List<Option>(2)
                {
                    new Option(new bool[]{true}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false}, new int[8]{0,0,0,0,0,0,0,0}),
                },
                new List<Option>(4)
                {
                    new Option(new bool[]{true,true}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false}, new int[8]{0,0,0,0,0,0,0,0}),
                },
                new List<Option>(7)
                {
                    new Option(new bool[]{true,true,true}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false}, new int[8]{0,0,0,0,0,0,0,0}),
                },
                new List<Option>(12)
                {
                    new Option(new bool[]{true,true,true,true}, new int[8]{0,0,0,1,0,0,0,0}),
                    new Option(new bool[]{true,true,true,false}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,true}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false}, new int[8]{0,0,0,0,0,0,0,0}),
                },
                new List<Option>(21)
                {
                    new Option(new bool[]{true,true,true,true,true}, new int[8]{0,0,0,0,1,0,0,0}),
                    new Option(new bool[]{true,true,true,true,false}, new int[8]{0,0,0,1,0,0,0,0}),
                    new Option(new bool[]{true,true,true,false,false}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,true}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,true,true}, new int[8]{0,0,0,1,0,0,0,0}),
                    new Option(new bool[]{false,true,true,true,false}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,false,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,true}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,true}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,true}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,true}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,false}, new int[8]{0,0,0,0,0,0,0,0}),
                },
                new List<Option>(37)
                {
                    new Option(new bool[]{true,true,true,true,true,true}, new int[8]{0,0,0,0,0,1,0,0}),
                    new Option(new bool[]{true,true,true,true,true,false}, new int[8]{0,0,0,0,1,0,0,0}),
                    new Option(new bool[]{true,true,true,true,false,false}, new int[8]{0,0,0,1,0,0,0,0}),
                    new Option(new bool[]{true,true,true,false,false,true}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,true,false,false,false}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,true,true}, new int[8]{0,2,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,true,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,false,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,false,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,true,true}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,true,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,false,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,true,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,true,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,false,true}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,true,true,true}, new int[8]{0,0,0,0,1,0,0,0}),
                    new Option(new bool[]{false,true,true,true,true,false}, new int[8]{0,0,0,1,0,0,0,0}),
                    new Option(new bool[]{false,true,true,true,false,false}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,false,false,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,false,false,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,true,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,true,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,false,true}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,true,true}, new int[8]{0,0,0,1,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,true,false}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,false,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,false,false,true}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,false,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,true,true}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,true,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,true,true}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,true,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,false,true}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,false,false}, new int[8]{0,0,0,0,0,0,0,0}),
                },
                new List<Option>(65)
                {
                    new Option(new bool[]{true,true,true,true,true,true,true}, new int[8]{0,0,0,0,0,0,1,0}),
                    new Option(new bool[]{true,true,true,true,true,true,false}, new int[8]{0,0,0,0,0,1,0,0}),
                    new Option(new bool[]{true,true,true,true,true,false,false}, new int[8]{0,0,0,0,1,0,0,0}),
                    new Option(new bool[]{true,true,true,true,false,false,true}, new int[8]{1,0,0,1,0,0,0,0}),
                    new Option(new bool[]{true,true,true,true,false,false,false}, new int[8]{0,0,0,1,0,0,0,0}),
                    new Option(new bool[]{true,true,true,false,false,true,true}, new int[8]{0,1,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,true,false,false,true,false}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,true,false,false,false,true}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,true,false,false,false,false}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,true,true,true}, new int[8]{0,1,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,true,true,false}, new int[8]{0,2,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,true,false,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,false,true,true}, new int[8]{0,2,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,false,true,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,false,false,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,false,false,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,true,true,true}, new int[8]{1,0,0,1,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,true,true,false}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,true,false,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,false,false,true}, new int[8]{3,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,false,false,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,true,true,true}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,true,true,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,true,false,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,false,true,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,false,true,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,false,false,true}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,false,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,true,true,true,true}, new int[8]{0,0,0,0,0,1,0,0}),
                    new Option(new bool[]{false,true,true,true,true,true,false}, new int[8]{0,0,0,0,1,0,0,0}),
                    new Option(new bool[]{false,true,true,true,true,false,false}, new int[8]{0,0,0,1,0,0,0,0}),
                    new Option(new bool[]{false,true,true,true,false,false,true}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,true,false,false,false}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,false,false,true,true}, new int[8]{0,2,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,false,false,true,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,false,false,false,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,false,false,false,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,true,true,true}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,true,true,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,true,false,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,false,true,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,false,true,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,false,false,true}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,false,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,true,true,true}, new int[8]{0,0,0,0,1,0,0,0}),
                    new Option(new bool[]{false,false,true,true,true,true,false}, new int[8]{0,0,0,1,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,true,false,false}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,false,false,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,false,false,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,false,false,true,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,false,false,true,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,false,false,false,true}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,false,false,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,true,true,true}, new int[8]{0,0,0,1,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,true,true,false}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,true,false,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,false,false,true}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,false,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,true,true,true}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,true,true,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,true,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,false,true,true}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,false,true,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,false,false,true}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,false,false,false}, new int[8]{0,0,0,0,0,0,0,0}),
                },
                new List<Option>(114)
                {
                    new Option(new bool[]{true,true,true,true,true,true,true,true}, new int[8]{0,0,0,0,0,0,0,1}),
                    new Option(new bool[]{true,true,true,true,true,true,true,false}, new int[8]{0,0,0,0,0,0,1,0}),
                    new Option(new bool[]{true,true,true,true,true,true,false,false}, new int[8]{0,0,0,0,0,1,0,0}),
                    new Option(new bool[]{true,true,true,true,true,false,false,true}, new int[8]{1,0,0,0,1,0,0,0}),
                    new Option(new bool[]{true,true,true,true,true,false,false,false}, new int[8]{0,0,0,0,1,0,0,0}),
                    new Option(new bool[]{true,true,true,true,false,false,true,true}, new int[8]{0,1,0,1,0,0,0,0}),
                    new Option(new bool[]{true,true,true,true,false,false,true,false}, new int[8]{1,0,0,1,0,0,0,0}),
                    new Option(new bool[]{true,true,true,true,false,false,false,true}, new int[8]{1,0,0,1,0,0,0,0}),
                    new Option(new bool[]{true,true,true,true,false,false,false,false}, new int[8]{0,0,0,1,0,0,0,0}),
                    new Option(new bool[]{true,true,true,false,false,true,true,true}, new int[8]{0,0,2,0,0,0,0,0}),
                    new Option(new bool[]{true,true,true,false,false,true,true,false}, new int[8]{0,1,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,true,false,false,true,false,false}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,true,false,false,false,true,true}, new int[8]{0,1,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,true,false,false,false,true,false}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,true,false,false,false,false,true}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,true,false,false,false,false,false}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,true,true,true,true}, new int[8]{0,1,0,1,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,true,true,true,false}, new int[8]{0,1,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,true,true,false,false}, new int[8]{0,2,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,true,false,false,true}, new int[8]{2,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,true,false,false,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,false,true,true,true}, new int[8]{0,1,1,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,false,true,true,false}, new int[8]{0,2,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,false,true,false,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,false,false,true,true}, new int[8]{0,2,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,false,false,true,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,false,false,false,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,true,false,false,false,false,false,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,true,true,true,true}, new int[8]{1,0,0,0,1,0,0,0}),
                    new Option(new bool[]{true,false,false,true,true,true,true,false}, new int[8]{1,0,0,1,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,true,true,false,false}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,true,false,false,true}, new int[8]{2,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,true,false,false,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,false,false,true,true}, new int[8]{2,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,false,false,true,false}, new int[8]{3,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,false,false,false,true}, new int[8]{3,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,true,false,false,false,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,true,true,true,true}, new int[8]{1,0,0,1,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,true,true,true,false}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,true,true,false,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,true,false,false,true}, new int[8]{3,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,true,false,false,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,false,true,true,true}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,false,true,true,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,false,true,false,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,false,false,true,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,false,false,true,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,false,false,false,true}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{true,false,false,false,false,false,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,true,true,true,true,true}, new int[8]{0,0,0,0,0,0,1,0}),
                    new Option(new bool[]{false,true,true,true,true,true,true,false}, new int[8]{0,0,0,0,0,1,0,0}),
                    new Option(new bool[]{false,true,true,true,true,true,false,false}, new int[8]{0,0,0,0,1,0,0,0}),
                    new Option(new bool[]{false,true,true,true,true,false,false,true}, new int[8]{1,0,0,1,0,0,0,0}),
                    new Option(new bool[]{false,true,true,true,true,false,false,false}, new int[8]{0,0,0,1,0,0,0,0}),
                    new Option(new bool[]{false,true,true,true,false,false,true,true}, new int[8]{0,1,1,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,true,false,false,true,false}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,true,false,false,false,true}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,true,false,false,false,false}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,false,false,true,true,true}, new int[8]{0,1,1,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,false,false,true,true,false}, new int[8]{0,2,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,false,false,true,false,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,false,false,false,true,true}, new int[8]{0,2,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,false,false,false,true,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,false,false,false,false,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,true,false,false,false,false,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,true,true,true,true}, new int[8]{1,0,0,1,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,true,true,true,false}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,true,true,false,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,true,false,false,true}, new int[8]{3,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,true,false,false,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,false,true,true,true}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,false,true,true,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,false,true,false,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,false,false,true,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,false,false,true,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,false,false,false,true}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,true,false,false,false,false,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,true,true,true,true}, new int[8]{0,0,0,0,0,1,0,0}),
                    new Option(new bool[]{false,false,true,true,true,true,true,false}, new int[8]{0,0,0,0,1,0,0,0}),
                    new Option(new bool[]{false,false,true,true,true,true,false,false}, new int[8]{0,0,0,1,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,true,false,false,true}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,true,false,false,false}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,false,false,true,true}, new int[8]{0,2,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,false,false,true,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,false,false,false,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,true,false,false,false,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,false,false,true,true,true}, new int[8]{1,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,false,false,true,true,false}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,false,false,true,false,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,false,false,false,true,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,false,false,false,true,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,false,false,false,false,true}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,true,false,false,false,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,true,true,true,true}, new int[8]{0,0,0,0,1,0,0,0}),
                    new Option(new bool[]{false,false,false,true,true,true,true,false}, new int[8]{0,0,0,1,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,true,true,false,false}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,true,false,false,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,true,false,false,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,false,false,true,true}, new int[8]{1,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,false,false,true,false}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,false,false,false,true}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,true,false,false,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,true,true,true,true}, new int[8]{0,0,0,1,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,true,true,true,false}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,true,true,false,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,true,false,false,true}, new int[8]{2,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,true,false,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,false,true,true,true}, new int[8]{0,0,1,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,false,true,true,false}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,false,true,false,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,false,false,true,true}, new int[8]{0,1,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,false,false,true,false}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,false,false,false,true}, new int[8]{1,0,0,0,0,0,0,0}),
                    new Option(new bool[]{false,false,false,false,false,false,false,false}, new int[8]{0,0,0,0,0,0,0,0}),
                }
            };
        }
        public static void RemoveOptions(int groupSize, List<List<Option>> optionsLists)
        {
            for (int i = 0; i < optionsLists.Count; i++)
            {
                var optionList = optionsLists[i];
                for (int j = optionList.Count - 1; j >= 0; j--)
                {
                    if (optionList[j].Groups[groupSize] != 0)
                    {
                        optionList.RemoveAt(j);
                    }
                }
            }
        }
    }
}
